/* 
* Copyright (C) 2005-2008 MaNGOS <http://www.mangosproject.org/>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef MANGOS_POINTMOVEMENTGENERATOR_H
#define MANGOS_POINTMOVEMENTGENERATOR_H

#include "MovementGenerator.h"
#include "DestinationHolder.h"
#include "Traveller.h"
#include "FollowerReference.h"

template<class T>
class MANGOS_DLL_SPEC PointMovementGenerator
    : public MovementGeneratorMedium< T, PointMovementGenerator<T> >
{
public:
    PointMovementGenerator(uint32 _id, float _x, float _y, float _z) : id(_id), 
        x(_x), y(_y), z(_z), i_nextMoveTime(0) {}

    void Initialize(T &);
    void Finalize(T &){}
    void Reset(T &unit){unit.StopMoving();}
    bool Update(T &, const uint32 &diff);

    void MovementInform(T &);

    MovementGeneratorType GetMovementGeneratorType() { return POINT_MOTION_TYPE; }

private:
    TimeTracker i_nextMoveTime;
    float x,y,z;
    uint32 id;
    DestinationHolder< Traveller<T> > i_destinationHolder;
};
#endif
